Subject: Re: [octave ] LOADPATH recurses only one level of subdirectories
From: "Larrie Carr" <[email-masked]>
To: "John W. Eaton" <[email-masked]>
Cc: <[email-masked]>
Date: Thu, 9 Feb 2006 12:47:52 -0800

> | In short, octave-forge is non-functional as it uses multiple 
> subdirectories.
>
> If that's true for everyone, then I'm surprised as I think you are the
> first to report it.
>
Sorry about the tone - it's not functional for me, while everyone else is 
happy.  I've tried a clean new cygwin installation using setup and pulled 
the octave installation through there - no more easy stuff to do.  Digging 
through new C++ code makes my head hurt (I'm more of a VHDL/C kind of guy).

> Probably the code you are looking for is the function do_subdir in
> liboctave/kpse.cc.  This file contains a stripped-down version of the
> kpathsearch library.  Most modifications were to remove TeX-specific
> stuff and to convert it to use std::string instead of plain C strings
> which historically leaked memory.  In any case, that function may use
> an optimization to decide when to check for subdirectories.  The
> optimization looks at the link count of the current directory.  If it
> is 2, then the assumption is that the current directory does not
> contain any subdirectories.  That seems to work fine for Unixy
> systems.  Does that assumption not hold for Cygwin?  If so, then I
> think the fix is fairly simple as there is also Windows-specific code
> in that function.  Whether the optimization is performed depends on
> what is #defined at compile time, so you'll probably have to do some
> checking on a Cygwin system to see what is really going on.

thanks for the pointer - I will have a look. 

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/